(function() {
	var rtagname = /<([\w:]+)/, wrapMap = {
		option: [1, "<select multiple='multiple'>", "</select>"],
		legend: [1, "<fieldset>", "</fieldset>"],
		ul: [1, "<ul>", "</ul>"],
		li: [1, "<li>", "</li>"],
		_default: [0, "", ""]
	};
    window._$ = window.$;
    var $ = window.$ = function(s) {
        return new $.fn.init(s);
    };
    $.fn = $.prototype = {
        init: function(s) {
            this.dom = null;
            if (!s) return this;
			if (typeof s == 'string') {
				this.dom = document.getElementById(s.replace('#', ''));
			}
			else if(s.nodeType){
				this.dom = s;
			}
			else if (s.attr) {
				return s;
			} 
			return this;
        }
    };
    $.fn.extend = function(p) {
        for (var key in p) {
            if (!$.fn[key]) {
                $.fn[key] = p[key];
            }
        }
    };
    $.fn.init.prototype = $.fn;
    //append
	function clean(els, ctx, frag) {
		var ret = [], i, el;
		for (i = 0; (el = els[i]) != null; i++) {
			if (isS(el))
				el = fragDiv(el, ctx);
			if (el.nodeType)
				ret.push(el);
			else
				ret = $.merge(ret, el);
		}
		if (frag)
			for (i = 0; i < ret.length; i++)
				if (ret[i].nodeType)
					frag.appendChild(ret[i]);
		return ret;
	};
	function fragDiv(html, ctx) {
		var div = (ctx || document).createElement('div');
		var tag = (rtagname.exec(html) || ["", ""])[1].toLowerCase();
		var wrap = wrapMap[tag] || wrapMap._default, depth = wrap[0];
		div.innerHTML = wrap[1] + html + wrap[2];
		while (depth--) div = div.lastChild;
		return div;
	};
	$.merge = function(a1, a2) {
		var i = a1.length, j = 0;
		if (typeof a2.length == 'number') for (var l = a2.length; j < l; j++) a1[i++] = a2[j];
		else while (a2[j] !== undefined) a1[i++] = a2[j++];
		a1.length = i;
		return a1;
	};
	$.htmlFrag = function(html, ctx, frag) {
		ctx = ((ctx || document) || ctx.ownerDocument || ctx.dom && ctx.dom.ownerDocument || document);
		frag = frag || ctx.createDocumentFragment();
		if (Fw.isArray(html)) return clean(html, ctx, frag) && frag;
		var div = fragDiv(html);
		while (div.firstChild) frag.appendChild(div.firstChild);
		return frag;
	};
	//event
	var handlers = {}, _eventId= 1, evtMap;
	function eventId(el){
		return el._eventId || (el._eventId = _eventId++);
	};
	function parseEvt(evt){
		if(!evtMap && Fw.os === 'web'){
			evtMap = {
				touchstart: 'mousedown',
				touchend: 'mouseup'
			};
		}
		var parts = (evtMap ? evtMap[evt] || evt : evt).split('.');
		return {e: parts[0], ns: parts.slice(1).sort().join(' ')};
	};
	function bind(o, type, fn) {
		if (o.addEventListener)
			o.addEventListener(type, fn, false);
		else {
			o['e' + type + fn] = fn;
			o[type + fn] = function() {
				o['e' + type + fn](window.event, this);
			};
			o.attachEvent('on' + type, o[type + fn]);
		}
	};
	function addEvt(el, evts, fn, sel, delegate){
		var id = eventId(el);
		var set = (handlers[id] || (handlers[id] = []));
		Fw.each(evts.split(/\s/), function(evt){
			var handler = parseEvt(evt);
			Fw.apply(handler, {fn: fn, sel: sel, del: delegate, i: set.length});
			set.push(handler);
			bind(el, handler.e, delegate || fn);
		});
		el = null;
	};
	//ajax
	$.ajax = function(url, postStr, lastfunc, errfunc) {
	    var ajax = false;
	    if (window.XMLHttpRequest) {
	        ajax = new XMLHttpRequest();
	        if (ajax.overrideMimeType) {
	            ajax.overrideMimeType('text/xml');
	        }
	    }
	    else if (window.ActiveXObject) {
	        try {
	            ajax = new ActiveXObject('Msxml2.XMLHTTP');
	        }
	        catch(e) {
	            try {
	                ajax = new ActiveXObject('Microsoft.XMLHTTP');
	            }
	            catch(e) {}
	        }
	    }
	    if (!ajax) {
	        if (errfunc) errfunc();
	        return false;
	    }
	    //davi+
	    if(!Fw.isUrl(url)){
	    	url = Fw.getBasePath() + url;
	    }
	    if(Fw.isObject(postStr)){
	    	postStr = Fw.encode(postStr);
	    	if(postStr ==='{}') postStr = '';
	    }
	    url += (url.indexOf('?') > 0 ? '&' : '?') + 't=' + new Date().getTime();
	    //end
	    ajax.open('POST', url, true);
	    ajax.setRequestHeader('Content-Type', 'application/json');
	    ajax.send(postStr || '');
	    ajax.onreadystatechange = function() {
	    	if(!ajax.cancel){//davi+
		        if (ajax.readyState == 4 && ajax.status == 200) {
		            if (lastfunc) lastfunc(ajax.responseText);
		        }
	    	}
	    };
	    return ajax;
	};
	//
	$().extend({
	    html: function(val) {
	        return val == undefined ? (this.dom ? this.dom.innerHTML : null) : this.dom.innerHTML = val;
	    },
	    append: function(){
		    return this.domManip(arguments, true, function(el){
		      if (this.nodeType === 1)
		        this.appendChild(el);
		    });
	    },
	    empty: function() {
	        this.dom.innerHTML = '';
	        return this;
	    },
		attr : function(name, value) {
			if (value == undefined) {
				return this.dom.getAttribute(name);
			} else {
				if(Fw.isEmpty(value)){
					this.dom.removeAttribute(name);
				}else{
					this.dom.setAttribute(name, value);
				}
				return this;
			}
		},
		parent : function() {
			return $(this.dom.parentNode);
		},
		parents: function(cls){
			var parent = this.parent();
			if(!cls || !parent) return null;
			if(parent.hasClass(cls)){
				return parent;
			}
			return parent.parents(cls);
		},
		next: function(el){
			return nth(el, 2, "nextSibling");
		},
		hide : function() {
			this.dom.style.setProperty('display', 'none', 'important');
			return this;
		},
		show : function() {
			this.dom.style.removeProperty('display');
			this.removeClass('hidden');
			return this;
		},
	    css: function() {
	        if (!this.dom || arguments.length <= 0) return this;
	        if (arguments.length == 1 && typeof arguments[0] == 'string') {
	            arguments[0] = arguments[0].toLowerCase();
	            return this.dom.currentStyle ? 
	            this.dom.currentStyle[arguments[0]] : 
	            window.getComputedStyle(this.dom, '').getPropertyValue(arguments[0].replace(/([A-Z])/g, ' - $1'));
	        }
	        else if (arguments.length >= 2) {
	            this.dom.style[arguments[0]] = arguments[1];
	        }
	    },
	    hasClass: function(name) {
	        if (!this.dom) return this;
	        var allClass = (this.dom.className || '').split(' ');
	        for (var key in allClass)
	        if (allClass[key] == name) return true;
	        return false;
	    },
	    addClass: function(name) {
	        if (this.dom && this.dom.nodeType == 1){
	        	this.dom.className += ' ' + name;
	        }
	        return this;
	    },
	    removeClass: function(name) {
	        if (this.dom){
	            var temp = [],
	            allClass = this.dom.className.split(' ');
	            for (var j = 0, k = 0; j < allClass.length; j++) {
	                if (allClass[j] != name) {
	                    temp[k++] = allClass[j];
	                }
	            }
	            allClass = temp.join(' ');
	            this.dom.className = allClass;
	        }
	        return this;
	    },
		val: function(value) {
			var tagName = this.dom.tagName.toLocaleLowerCase();
			if (value == undefined) {
				if (/input|select/.test(tagName)) {
					return this.dom.value;
				} 
				else if (/radio|checkbox/.test(tagName)) {
				} 
				else {
					return this.dom.innerHTML;
				}
			} 
			else {
				if (/input|select/.test(tagName)) {
					this.dom.value = value;
				} 
				else if (/radio|checkbox/.test(tagName)) {
				} 
				else {
					this.dom.innerHTML = value;
				}
				return this;
			}
		},
		on: function(evt, sel, cb){
			if(typeof sel === 'function'){
				return addEvt(this.dom, evt, sel);
			}
			else{
//				return this['each'](function(i, el){
//				addEvt(el, evt, cb, sel, function(e) {
//								var target = e.target || e.srcElement, nodes = $['$$'](
//										sel, el);
//								while (target
//										&& $['_indexOf'](nodes, target) < 0)
//									target = target.parentNode;
//								if (target && !(target === el)
//										&& !(target === document)) {
//									cb.call(target, $['extend'](createProxy(e
//															|| window.event), {
//														currentTarget : target,
//														liveFired : el
//													}));
//								}
//							});
//				});
			}
		},
		domManip: function(args, tbl, cb) {
			var value = args[0], parent, frag, first;
			if (value) {
				if (this.dom) {
					frag = value.nodeType;
					if (!(frag === 3 && value)) {
						parent = value && value.parentNode;
						frag = parent && parent.nodeType === 11 && parent.childNodes.length === this.length ? parent : $.htmlFrag(value);
						first = frag.firstChild;
						if (frag.childNodes.length === 1) frag = first;
						if (!first) return this;
					}
					cb.call(this.dom, frag);
				}
			}
			return this;
		}
	});
})();