/**
 * @name Fw.device.Web
 * @class 设备交互接口
 * @example : <br>
 *          Fw.device.Client.openWaitPanel();<br>
 *          Fw.device.Client.hideWaitPanel();\n
 */
Fw.device.Web = function(){
};
Fw.override(Fw.device.Web, {
	/**
	 * 开启等待层
	 */
	openWaitPanel : function() {
		alert("iphone: openWaitPanel");
	},
	/**
	 * 关闭等待层
	 */
	hideWaitPanel : function() {
	},
	/**
	 * 弹出信息
	 * 
	 * @example : <br>
	 * 
	 */
	alertinfo : function(cfg) {
		alert(cfg);
	},
	/**
	 * 返回系统首页
	 */
	gotoHomePage : function() {

	},
	/**
	 * 九宫格页面
	 */
	gotoIndexPage : function() {

	},
	/**
	 * 登录成功后跳转到欢迎页
	 */
	gotoWelcomePage : function() {

	},
	/**
	 * 显示日期键盘
	 * 
	 * @param obj
	 * @example <br>
	 *          &lt;input type="text" id="startDate" data-min="" data-max=""
	 *          data-startId="" data-endId="" readOnly
	 *          onclick="Fw.device.Client.showDatePicker(this)"&gt; <br>
	 */
	showDatePicker : function(obj) {
		$(obj).attr("type","date").on("click",null);
		$(obj).attr("readOnly",null).attr("readonly",null);
	},
	/**
	 * 显示安全键盘
	 * 
	 * @example <br>
	 *          &gt;input type="password" id="password" data-maxlength=""
	 *          data-minlength="" data-kind="" （键盘模式）
	 *          onclick="Fw.device.Client.showPwdPicker(this)"&gt; <br>
	 */
	showPwdPicker : function(obj) {
		$(obj).attr("type","password").on("click",null);
		$(obj).attr("readOnly",null).attr("readonly",null);
		
	},
	/**
	 * 显示金额键盘
	 * 
	 * @param obj
	 */
	showMoneyPicker : function(obj) {
		$(obj).attr("readOnly",null).attr("readonly",null).on("click",null);
	},
	/**
	 * 加密数据
	 * 
	 * @param obj
	 */
	encryptTransData : function(obj) { 
	},
	/**
	 * 服务端超时
	 */
	sessionTimeOut : function() {
	}
});

//
Fw.device.Client = new Fw.device.Web();
