/**
 * @name Fw.Component
 * @class 组件基类
 * @constructor
 * @example
 * @return
 */
Fw.Component = function(config){
	Fw.apply(this, config);
	//call parent
	Fw.Component.superclass.constructor.call(this);
	//初始化组件
	this.initComponent();
	//初始化事件
	this.initEvents();
	//完成渲染
	this.finishRender();
	return this;
};
Fw.extend(Fw.Component, Fw.util.Observable, {
	/**
	 * 数据ROOT
	 * @type String
	 */
	dataField: 'LIST',
	/**
	 * 分页起始行
	 * @type String
	 */
	pageStartField: 'startId',
	/**
	 * 分页行数
	 * @type String
	 */
	pageLimitField: 'pageSize',
	/**
	 * 初始化组件
	 */
	initComponent: function(){
		//EL
		this.el = $(this.contentEl);
		//初始化渲染模板
		this.initTpl();
	},
	/**
	 * 初始化事件
	 */
	initEvents: Fw.emptyFn,
	/**
	 * 初始化HTML模版
	 */
	initTpl: Fw.emptyFn,
	/**
	 * 完成渲染
	 */
	finishRender: function(){
		this.fireEvent('render', this);
	}
});