/**
 * @name Fw.Group
 * @class 选择组件，单选，多选, 多选组
 * @constructor
 * @example
 * @return
 */
Fw.Group = Fw.extend(Fw.Component, {
	radioGroup : function(root) {
		Fw.log("----radioGroup-start---", "Fw.Group");
		var group = root.dom;
		this.groupObj = root;
		var nodes = group.children;
		Fw.each(nodes, function(node, index) {
			node = $(node);
			if (node.hasClass("selected")) {
				// Fw.log("----radioGroup-selected---" + index, "Fw.Group");
				this.activeNode = node;
				this.groupObj.attr("value", node.attr("value"));
				// Fw.log("----radioGroup-value---" + this.value(), "Fw.Group");
			}
			// Fw.log("----radioGroup-each---" + index, "Fw.Group");
			node.on(NS.ON_CLICK, Fw.bind(this._radioCheck, this));
		}, this);
		// Fw.log("----radioGroup-end---", "Fw.Group");
	},
	checkBoxGroup : function() {
	},
	setValue : function(root,v) {
		var group = root.dom;
		this.groupObj = root;
		var nodes = group.children;
		Fw.each(nodes, function(node, index) {
			node = $(node);
			if (node.attr("value") == v) {
				this.activeNode = node;
				this.groupObj.attr("value", node.attr("value"));
				node.addClass("selected");
			}else{
				this.activeNode = node;
				node.removeClass("selected");
			}
			node.on(NS.ON_CLICK, Fw.bind(this._radioCheck, this));
		}, this);
	},
	value : function() {
		return this.groupObj.attr("value");
	},
	_radioCheck : function(e) {
		Fw.log("----radioGroup-click start---", "Fw.Group");
		var node = $(e.target);
		var parent = this.groupObj;
		// Fw.log("----radioGroup-id---" + parent.attr("id"), "Fw.Group");
		this.activeNode.removeClass("selected");
		$(node).addClass("selected");
		this.activeNode = node;
		// 将li.selected当前值赋给ul
		parent.attr("value", $(node).attr("value"));
		// Fw.log("----radioGroup-click end---", "Fw.Group");
		Fw.log("----radioGroup-value---" + this.value(), "Fw.Group");
	}
});